#ifndef arf_h_
#define arf_h_


class Arf {
 private:
  static const int STEPUP_THRESHOLD = 4; // 4 consecutive tx before increasing
  static const int FALLBACK_THRESHOLD = 2; // 2 consecutive tx failures before decreasing
  static const int PROBATION_SIZE = 1;

  int currentRate;
  int consecutiveSuccess;
  int consecutiveFailures;
  int probationNumber; // Number of tries left to get a packet through at the new rate

 public:
  Arf();
  void successfulTransmission();
  void failedTransmission();
  double getTransmissionRate();
};

#endif
